#include "php_gtk.h"
#if HAVE_PHP_GTK

#include <gtkscintilla.h>
#include "ext/gtk+/php_gtk+.h"

void php_scintilla_register_constants(int module_number TSRMLS_DC)
{

	REGISTER_LONG_CONSTANT("SCINTILLA_INVALID_POSITION", INVALID_POSITION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_WS_INVISIBLE", SCWS_INVISIBLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_WS_VISIBLEALWAYS", SCWS_VISIBLEALWAYS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_WS_VISIBLEAFTERINDENT", SCWS_VISIBLEAFTERINDENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EOL_CRLF", SC_EOL_CRLF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EOL_CR", SC_EOL_CR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EOL_LF", SC_EOL_LF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CP_UTF8", SC_CP_UTF8, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARKER_MAX", MARKER_MAX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_CIRCLE", SC_MARK_CIRCLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_ROUNDRECT", SC_MARK_ROUNDRECT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_ARROW", SC_MARK_ARROW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_SMALLRECT", SC_MARK_SMALLRECT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_SHORTARROW", SC_MARK_SHORTARROW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_EMPTY", SC_MARK_EMPTY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_ARROWDOWN", SC_MARK_ARROWDOWN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_MINUS", SC_MARK_MINUS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARK_PLUS", SC_MARK_PLUS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARKNUM_FOLDER", SC_MARKNUM_FOLDER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARKNUM_FOLDEROPEN", SC_MARKNUM_FOLDEROPEN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARGIN_SYMBOL", SC_MARGIN_SYMBOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MARGIN_NUMBER", SC_MARGIN_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_STYLE_DEFAULT", STYLE_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_STYLE_LINENUMBER", STYLE_LINENUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_STYLE_BRACELIGHT", STYLE_BRACELIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_STYLE_BRACEBAD", STYLE_BRACEBAD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_STYLE_CONTROLCHAR", STYLE_CONTROLCHAR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_STYLE_INDENTGUIDE", STYLE_INDENTGUIDE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_STYLE_MAX", STYLE_MAX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_ANSI", SC_CHARSET_ANSI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_DEFAULT", SC_CHARSET_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_BALTIC", SC_CHARSET_BALTIC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_CHINESEBIG5", SC_CHARSET_CHINESEBIG5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_EASTEUROPE", SC_CHARSET_EASTEUROPE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_GB2312", SC_CHARSET_GB2312, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_GREEK", SC_CHARSET_GREEK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_HANGUL", SC_CHARSET_HANGUL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_MAC", SC_CHARSET_MAC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_OEM", SC_CHARSET_OEM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_RUSSIAN", SC_CHARSET_RUSSIAN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_SHIFTJIS", SC_CHARSET_SHIFTJIS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_SYMBOL", SC_CHARSET_SYMBOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_TURKISH", SC_CHARSET_TURKISH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_JOHAB", SC_CHARSET_JOHAB, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_HEBREW", SC_CHARSET_HEBREW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_ARABIC", SC_CHARSET_ARABIC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_VIETNAMESE", SC_CHARSET_VIETNAMESE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CHARSET_THAI", SC_CHARSET_THAI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CASE_MIXED", SC_CASE_MIXED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CASE_UPPER", SC_CASE_UPPER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CASE_LOWER", SC_CASE_LOWER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC_MAX", INDIC_MAX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC_PLAIN", INDIC_PLAIN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC_SQUIGGLE", INDIC_SQUIGGLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC_TT", INDIC_TT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC_DIAGONAL", INDIC_DIAGONAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC_STRIKE", INDIC_STRIKE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC0_MASK", INDIC0_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC1_MASK", INDIC1_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDIC2_MASK", INDIC2_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_INDICS_MASK", INDICS_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_FIND_WHOLEWORD", SCFIND_WHOLEWORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_FIND_MATCHCASE", SCFIND_MATCHCASE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_FIND_WORDSTART", SCFIND_WORDSTART, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_FIND_REGEXP", SCFIND_REGEXP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_FOLDLEVELBASE", SC_FOLDLEVELBASE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_FOLDLEVELWHITEFLAG", SC_FOLDLEVELWHITEFLAG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_FOLDLEVELHEADERFLAG", SC_FOLDLEVELHEADERFLAG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_FOLDLEVELNUMBERMASK", SC_FOLDLEVELNUMBERMASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EDGE_NONE", EDGE_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EDGE_LINE", EDGE_LINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EDGE_BACKGROUND", EDGE_BACKGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CARET_SLOP", CARET_SLOP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CARET_CENTER", CARET_CENTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CARET_STRICT", CARET_STRICT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CARET_XEVEN", CARET_XEVEN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CURSORNORMAL", SC_CURSORNORMAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CURSORWAIT", SC_CURSORWAIT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_VISIBLE_SLOP", VISIBLE_SLOP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_VISIBLE_STRICT", VISIBLE_STRICT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_INSERTTEXT", SC_MOD_INSERTTEXT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_DELETETEXT", SC_MOD_DELETETEXT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_CHANGESTYLE", SC_MOD_CHANGESTYLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_CHANGEFOLD", SC_MOD_CHANGEFOLD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERFORMED_USER", SC_PERFORMED_USER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERFORMED_UNDO", SC_PERFORMED_UNDO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERFORMED_REDO", SC_PERFORMED_REDO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LASTSTEPINUNDOREDO", SC_LASTSTEPINUNDOREDO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_CHANGEMARKER", SC_MOD_CHANGEMARKER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_BEFOREINSERT", SC_MOD_BEFOREINSERT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_BEFOREDELETE", SC_MOD_BEFOREDELETE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MODEVENTMASKALL", SC_MODEVENTMASKALL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EN_CHANGE", SCEN_CHANGE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EN_SETFOCUS", SCEN_SETFOCUS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EN_KILLFOCUS", SCEN_KILLFOCUS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_DOWN", SCK_DOWN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_UP", SCK_UP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_LEFT", SCK_LEFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_RIGHT", SCK_RIGHT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_HOME", SCK_HOME, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_END", SCK_END, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_PRIOR", SCK_PRIOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_NEXT", SCK_NEXT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_DELETE", SCK_DELETE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_INSERT", SCK_INSERT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_ESCAPE", SCK_ESCAPE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_BACK", SCK_BACK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_TAB", SCK_TAB, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_RETURN", SCK_RETURN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_ADD", SCK_ADD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_SUBTRACT", SCK_SUBTRACT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_KEY_DIVIDE", SCK_DIVIDE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_SHIFT", SCMOD_SHIFT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_CTRL", SCMOD_CTRL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MOD_ALT", SCMOD_ALT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_CONTAINER", SCLEX_CONTAINER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_NULL", SCLEX_NULL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_PYTHON", SCLEX_PYTHON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_CPP", SCLEX_CPP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_HTML", SCLEX_HTML, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_XML", SCLEX_XML, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_PERL", SCLEX_PERL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_SQL", SCLEX_SQL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_VB", SCLEX_VB, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_PROPERTIES", SCLEX_PROPERTIES, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_ERRORLIST", SCLEX_ERRORLIST, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_MAKEFILE", SCLEX_MAKEFILE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_BATCH", SCLEX_BATCH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_XCODE", SCLEX_XCODE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_LATEX", SCLEX_LATEX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_LUA", SCLEX_LUA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_DIFF", SCLEX_DIFF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_CONF", SCLEX_CONF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_PASCAL", SCLEX_PASCAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_AVE", SCLEX_AVE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_ADA", SCLEX_ADA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_LISP", SCLEX_LISP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_RUBY", SCLEX_RUBY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_EIFFEL", SCLEX_EIFFEL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_EIFFELKW", SCLEX_EIFFELKW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LEX_AUTOMATIC", SCLEX_AUTOMATIC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_DEFAULT", SCE_P_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_COMMENTLINE", SCE_P_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_NUMBER", SCE_P_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_STRING", SCE_P_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_CHARACTER", SCE_P_CHARACTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_WORD", SCE_P_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_TRIPLE", SCE_P_TRIPLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_TRIPLEDOUBLE", SCE_P_TRIPLEDOUBLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_CLASSNAME", SCE_P_CLASSNAME, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_DEFNAME", SCE_P_DEFNAME, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_OPERATOR", SCE_P_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_IDENTIFIER", SCE_P_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_COMMENTBLOCK", SCE_P_COMMENTBLOCK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PY_STRINGEOL", SCE_P_STRINGEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_DEFAULT", SCE_C_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_COMMENT", SCE_C_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_COMMENTLINE", SCE_C_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_COMMENTDOC", SCE_C_COMMENTDOC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_NUMBER", SCE_C_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_WORD", SCE_C_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_STRING", SCE_C_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_CHARACTER", SCE_C_CHARACTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_UUID", SCE_C_UUID, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_PREPROCESSOR", SCE_C_PREPROCESSOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_OPERATOR", SCE_C_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_IDENTIFIER", SCE_C_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_STRINGEOL", SCE_C_STRINGEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_VERBATIM", SCE_C_VERBATIM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_REGEX", SCE_C_REGEX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_C_COMMENTLINEDOC", SCE_C_COMMENTLINEDOC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_DEFAULT", SCE_H_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_TAG", SCE_H_TAG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_TAGUNKNOWN", SCE_H_TAGUNKNOWN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_ATTRIBUTE", SCE_H_ATTRIBUTE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_ATTRIBUTEUNKNOWN", SCE_H_ATTRIBUTEUNKNOWN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_NUMBER", SCE_H_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_DOUBLESTRING", SCE_H_DOUBLESTRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_SINGLESTRING", SCE_H_SINGLESTRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_OTHER", SCE_H_OTHER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_COMMENT", SCE_H_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_ENTITY", SCE_H_ENTITY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_TAGEND", SCE_H_TAGEND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_XMLSTART", SCE_H_XMLSTART, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_XMLEND", SCE_H_XMLEND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_SCRIPT", SCE_H_SCRIPT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_ASP", SCE_H_ASP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_ASPAT", SCE_H_ASPAT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_CDATA", SCE_H_CDATA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_QUESTION", SCE_H_QUESTION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VALUE", SCE_H_VALUE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_START", SCE_HJ_START, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_DEFAULT", SCE_HJ_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_COMMENT", SCE_HJ_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_COMMENTLINE", SCE_HJ_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_COMMENTDOC", SCE_HJ_COMMENTDOC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_NUMBER", SCE_HJ_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_WORD", SCE_HJ_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_KEYWORD", SCE_HJ_KEYWORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_DOUBLESTRING", SCE_HJ_DOUBLESTRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_SINGLESTRING", SCE_HJ_SINGLESTRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_SYMBOLS", SCE_HJ_SYMBOLS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_STRINGEOL", SCE_HJ_STRINGEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_JS_REGEX", SCE_HJ_REGEX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VB_START", SCE_HB_START, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VB_DEFAULT", SCE_HB_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VB_COMMENTLINE", SCE_HB_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VB_NUMBER", SCE_HB_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VB_WORD", SCE_HB_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VB_STRING", SCE_HB_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VB_IDENTIFIER", SCE_HB_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_VB_STRINGEOL", SCE_HB_STRINGEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_START", SCE_HP_START, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_DEFAULT", SCE_HP_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_COMMENTLINE", SCE_HP_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_NUMBER", SCE_HP_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_STRING", SCE_HP_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_CHARACTER", SCE_HP_CHARACTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_WORD", SCE_HP_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_TRIPLE", SCE_HP_TRIPLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_TRIPLEDOUBLE", SCE_HP_TRIPLEDOUBLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_CLASSNAME", SCE_HP_CLASSNAME, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_DEFNAME", SCE_HP_DEFNAME, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_OPERATOR", SCE_HP_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PY_IDENTIFIER", SCE_HP_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_DEFAULT", SCE_HPHP_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_HSTRING", SCE_HPHP_HSTRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_SIMPLESTRING", SCE_HPHP_SIMPLESTRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_WORD", SCE_HPHP_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_NUMBER", SCE_HPHP_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_VARIABLE", SCE_HPHP_VARIABLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_COMMENT", SCE_HPHP_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_COMMENTLINE", SCE_HPHP_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_HTML_PHP_HSTRING_VARIABLE", SCE_HPHP_HSTRING_VARIABLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_DEFAULT", SCE_PL_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_ERROR", SCE_PL_ERROR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_COMMENTLINE", SCE_PL_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_POD", SCE_PL_POD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_NUMBER", SCE_PL_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_WORD", SCE_PL_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_STRING", SCE_PL_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_CHARACTER", SCE_PL_CHARACTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_PUNCTUATION", SCE_PL_PUNCTUATION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_PREPROCESSOR", SCE_PL_PREPROCESSOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_OPERATOR", SCE_PL_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_IDENTIFIER", SCE_PL_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_SCALAR", SCE_PL_SCALAR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_ARRAY", SCE_PL_ARRAY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_HASH", SCE_PL_HASH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_SYMBOLTABLE", SCE_PL_SYMBOLTABLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_REGEX", SCE_PL_REGEX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_REGSUBST", SCE_PL_REGSUBST, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_LONGQUOTE", SCE_PL_LONGQUOTE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_BACKTICKS", SCE_PL_BACKTICKS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_DATASECTION", SCE_PL_DATASECTION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_HERE_DELIM", SCE_PL_HERE_DELIM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_HERE_Q", SCE_PL_HERE_Q, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_HERE_QQ", SCE_PL_HERE_QQ, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_HERE_QX", SCE_PL_HERE_QX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_STRING_Q", SCE_PL_STRING_Q, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_STRING_QQ", SCE_PL_STRING_QQ, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_STRING_QX", SCE_PL_STRING_QX, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_STRING_QR", SCE_PL_STRING_QR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_PERL_STRING_QW", SCE_PL_STRING_QW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LATEX_DEFAULT", SCE_L_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LATEX_COMMAND", SCE_L_COMMAND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LATEX_TAG", SCE_L_TAG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LATEX_MATH", SCE_L_MATH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LATEX_COMMENT", SCE_L_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_DEFAULT", SCE_LUA_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_COMMENT", SCE_LUA_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_COMMENTLINE", SCE_LUA_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_COMMENTDOC", SCE_LUA_COMMENTDOC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_NUMBER", SCE_LUA_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_WORD", SCE_LUA_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_STRING", SCE_LUA_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_CHARACTER", SCE_LUA_CHARACTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_LITERALSTRING", SCE_LUA_LITERALSTRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_PREPROCESSOR", SCE_LUA_PREPROCESSOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_OPERATOR", SCE_LUA_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_IDENTIFIER", SCE_LUA_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LUA_STRINGEOL", SCE_LUA_STRINGEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_DEFAULT", SCE_ERR_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_PYTHON", SCE_ERR_PYTHON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_GCC", SCE_ERR_GCC, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_MS", SCE_ERR_MS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_CMD", SCE_ERR_CMD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_BORLAND", SCE_ERR_BORLAND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_PERL", SCE_ERR_PERL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_DIFF_CHANGED", SCE_ERR_DIFF_CHANGED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_DIFF_ADDITION", SCE_ERR_DIFF_ADDITION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_DIFF_DELETION", SCE_ERR_DIFF_DELETION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ERR_DIFF_MESSAGE", SCE_ERR_DIFF_MESSAGE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_BAT_DEFAULT", SCE_BAT_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_BAT_COMMENT", SCE_BAT_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_BAT_WORD", SCE_BAT_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_BAT_LABEL", SCE_BAT_LABEL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_BAT_HIDE", SCE_BAT_HIDE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_BAT_COMMAND", SCE_BAT_COMMAND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_BAT_IDENTIFIER", SCE_BAT_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_BAT_OPERATOR", SCE_BAT_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MAKE_DEFAULT", SCE_MAKE_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MAKE_COMMENT", SCE_MAKE_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MAKE_PREPROCESSOR", SCE_MAKE_PREPROCESSOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MAKE_IDENTIFIER", SCE_MAKE_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MAKE_OPERATOR", SCE_MAKE_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_MAKE_IDEOL", SCE_MAKE_IDEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_DEFAULT", SCE_CONF_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_COMMENT", SCE_CONF_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_NUMBER", SCE_CONF_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_IDENTIFIER", SCE_CONF_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_EXTENSION", SCE_CONF_EXTENSION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_PARAMETER", SCE_CONF_PARAMETER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_STRING", SCE_CONF_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_OPERATOR", SCE_CONF_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_IP", SCE_CONF_IP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_CONF_DIRECTIVE", SCE_CONF_DIRECTIVE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_DEFAULT", SCE_AVE_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_COMMENT", SCE_AVE_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_NUMBER", SCE_AVE_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_WORD", SCE_AVE_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_KEYWORD", SCE_AVE_KEYWORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_STATEMENT", SCE_AVE_STATEMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_STRING", SCE_AVE_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_ENUM", SCE_AVE_ENUM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_STRINGEOL", SCE_AVE_STRINGEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_IDENTIFIER", SCE_AVE_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_AVE_OPERATOR", SCE_AVE_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_DEFAULT", SCE_ADA_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_COMMENT", SCE_ADA_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_NUMBER", SCE_ADA_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_WORD", SCE_ADA_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_STRING", SCE_ADA_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_CHARACTER", SCE_ADA_CHARACTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_OPERATOR", SCE_ADA_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_IDENTIFIER", SCE_ADA_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_ADA_STRINGEOL", SCE_ADA_STRINGEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LISP_DEFAULT", SCE_LISP_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LISP_COMMENT", SCE_LISP_COMMENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LISP_NUMBER", SCE_LISP_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LISP_KEYWORD", SCE_LISP_KEYWORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LISP_STRING", SCE_LISP_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LISP_STRINGEOL", SCE_LISP_STRINGEOL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LISP_IDENTIFIER", SCE_LISP_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_LISP_OPERATOR", SCE_LISP_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_DEFAULT", SCE_EIFFEL_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_COMMENTLINE", SCE_EIFFEL_COMMENTLINE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_NUMBER", SCE_EIFFEL_NUMBER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_WORD", SCE_EIFFEL_WORD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_STRING", SCE_EIFFEL_STRING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_CHARACTER", SCE_EIFFEL_CHARACTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_OPERATOR", SCE_EIFFEL_OPERATOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_IDENTIFIER", SCE_EIFFEL_IDENTIFIER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("SCINTILLA_EIFFEL_STRINGEOL", SCE_EIFFEL_STRINGEOL, CONST_CS | CONST_PERSISTENT);
}

PHP_GTK_EXPORT_CE(gtk_scintilla_ce);

/* object GtkScintilla  */

PHP_FUNCTION(gtk_scintilla_new)
{
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "")) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_scintilla_new();
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkScintilla object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_scintilla_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_scintilla_get_type());
}

PHP_FUNCTION(gtk_scintilla_find_text)
{
	int flags;
	char *text;
	long pos, chrg_min = 0, chrg_max,
		 text_min, text_max;
	GtkScintilla *scintilla = GTK_SCINTILLA(PHP_GTK_GET(this_ptr));

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is|ll", &flags, &text, &chrg_min,
							&chrg_max))
		return;

	if (ZEND_NUM_ARGS() < 4) {
		chrg_max = gtk_scintilla_get_line_end_position(scintilla, gtk_scintilla_get_line_count(scintilla));
	}

	RETURN_LONG(gtk_scintilla_find_text(scintilla, flags, text, chrg_min,
										chrg_max, &text_min, &text_max));
}
PHP_FUNCTION(gtk_scintilla_add_text)
{
	char *text;
	int len;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s#", &text, &len))
		return;
	
	gtk_scintilla_add_text(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), len, text);

	RETURN_NULL();
}

PHP_FUNCTION(gtk_scintilla_insert_text)
{
	long pos;
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &pos, &text))
		return;

	gtk_scintilla_insert_text(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos, text);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_clear_all)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_clear_all(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_clear_document_style)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_clear_document_style(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_length)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_length(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_char_at)
{
	long pos, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	php_retval = gtk_scintilla_get_char_at(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_current_pos)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_current_pos(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_anchor)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_anchor(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_style_at)
{
	long pos, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	php_retval = gtk_scintilla_get_style_at(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_redo)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_redo(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_undo_collection)
{
	long collect_undo;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &collect_undo))
		return;

	gtk_scintilla_set_undo_collection(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)collect_undo);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_select_all)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_select_all(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_save_point)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_set_save_point(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_can_redo)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_can_redo(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_marker_line_from_handle)
{
	long handle, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &handle))
		return;

	php_retval = gtk_scintilla_marker_line_from_handle(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)handle);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_marker_delete_handle)
{
	long handle;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &handle))
		return;

	gtk_scintilla_marker_delete_handle(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)handle);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_undo_collection)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_undo_collection(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_view_ws)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_view_ws(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_view_ws)
{
	long view_ws;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &view_ws))
		return;

	gtk_scintilla_set_view_ws(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)view_ws);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_position_from_point)
{
	long x, y, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &x, &y))
		return;

	php_retval = gtk_scintilla_position_from_point(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)x, (int)y);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_goto_line)
{
	long line;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	gtk_scintilla_goto_line(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_goto_pos)
{
	long pos;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	gtk_scintilla_goto_pos(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_anchor)
{
	long pos_anchor;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos_anchor))
		return;

	gtk_scintilla_set_anchor(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos_anchor);
	RETURN_NULL();
}

PHP_FUNCTION(gtk_scintilla_get_cur_line)
{
	int length, line_pos;
	char *text;
	GtkScintilla *scintilla = GTK_SCINTILLA(PHP_GTK_GET(this_ptr));

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	length = gtk_scintilla_line_length(scintilla, gtk_scintilla_line_from_position(scintilla, gtk_scintilla_get_current_pos(scintilla))) + 1;
	text = (char *)emalloc(length);

	/* This function null-terminates the resulting string. */
	line_pos = gtk_scintilla_get_cur_line(scintilla, length, text);

	*return_value = *php_gtk_build_value("(s#i)", text, length-1, line_pos);
}

PHP_FUNCTION(gtk_scintilla_get_end_styled)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_end_styled(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_convert_eols)
{
	long eol_mode;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &eol_mode))
		return;

	gtk_scintilla_convert_eols(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)eol_mode);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_eol_mode)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_eol_mode(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_eol_mode)
{
	long eol_mode;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &eol_mode))
		return;

	gtk_scintilla_set_eol_mode(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)eol_mode);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_start_styling)
{
	long pos, mask;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &pos, &mask))
		return;

	gtk_scintilla_start_styling(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos, (int)mask);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_styling)
{
	long length, style;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &length, &style))
		return;

	gtk_scintilla_set_styling(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)length, (int)style);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_buffered_draw)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_buffered_draw(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_buffered_draw)
{
	long buffered;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &buffered))
		return;

	gtk_scintilla_set_buffered_draw(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)buffered);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_tab_width)
{
	long tab_width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &tab_width))
		return;

	gtk_scintilla_set_tab_width(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)tab_width);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_tab_width)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_tab_width(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_code_page)
{
	long code_page;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &code_page))
		return;

	gtk_scintilla_set_code_page(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)code_page);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_use_palette)
{
	long use_palette;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &use_palette))
		return;

	gtk_scintilla_set_use_palette(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)use_palette);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_marker_define)
{
	long marker_number, marker_symbol;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &marker_number, &marker_symbol))
		return;

	gtk_scintilla_marker_define(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)marker_number, (int)marker_symbol);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_marker_set_fore)
{
	long marker_number, fore;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &marker_number, &fore))
		return;

	gtk_scintilla_marker_set_fore(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)marker_number, (long)fore);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_marker_set_back)
{
	long marker_number, back;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &marker_number, &back))
		return;

	gtk_scintilla_marker_set_back(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)marker_number, (long)back);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_marker_add)
{
	long line, marker_number, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line, &marker_number))
		return;

	php_retval = gtk_scintilla_marker_add(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line, (int)marker_number);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_marker_delete)
{
	long line, marker_number;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line, &marker_number))
		return;

	gtk_scintilla_marker_delete(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line, (int)marker_number);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_marker_delete_all)
{
	long marker_number;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &marker_number))
		return;

	gtk_scintilla_marker_delete_all(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)marker_number);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_marker_get)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_marker_get(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_marker_next)
{
	long line_start, marker_mask, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line_start, &marker_mask))
		return;

	php_retval = gtk_scintilla_marker_next(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line_start, (int)marker_mask);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_marker_previous)
{
	long line_start, marker_mask, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line_start, &marker_mask))
		return;

	php_retval = gtk_scintilla_marker_previous(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line_start, (int)marker_mask);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_margin_type_n)
{
	long margin, margin_type;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &margin, &margin_type))
		return;

	gtk_scintilla_set_margin_type_n(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)margin, (int)margin_type);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_margin_type_n)
{
	long margin, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &margin))
		return;

	php_retval = gtk_scintilla_get_margin_type_n(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)margin);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_margin_width_n)
{
	long margin, pixel_width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &margin, &pixel_width))
		return;

	gtk_scintilla_set_margin_width_n(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)margin, (int)pixel_width);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_margin_width_n)
{
	long margin, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &margin))
		return;

	php_retval = gtk_scintilla_get_margin_width_n(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)margin);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_margin_mask_n)
{
	long margin, mask;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &margin, &mask))
		return;

	gtk_scintilla_set_margin_mask_n(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)margin, (int)mask);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_margin_mask_n)
{
	long margin, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &margin))
		return;

	php_retval = gtk_scintilla_get_margin_mask_n(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)margin);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_margin_sensitive_n)
{
	long margin, sensitive;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &margin, &sensitive))
		return;

	gtk_scintilla_set_margin_sensitive_n(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)margin, (int)sensitive);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_margin_sensitive_n)
{
	long margin, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &margin))
		return;

	php_retval = gtk_scintilla_get_margin_sensitive_n(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)margin);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_style_clear_all)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_style_clear_all(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_fore)
{
	long style, fore;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &fore))
		return;

	gtk_scintilla_style_set_fore(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (long)fore);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_back)
{
	long style, back;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &back))
		return;

	gtk_scintilla_style_set_back(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (long)back);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_bold)
{
	long style, bold;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &bold))
		return;

	gtk_scintilla_style_set_bold(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (int)bold);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_italic)
{
	long style, italic;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &italic))
		return;

	gtk_scintilla_style_set_italic(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (int)italic);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_size)
{
	long style, size_points;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &size_points))
		return;

	gtk_scintilla_style_set_size(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (int)size_points);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_font)
{
	long style;
	char *font_name;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &style, &font_name))
		return;

	gtk_scintilla_style_set_font(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, font_name);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_eol_filled)
{
	long style, filled;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &filled))
		return;

	gtk_scintilla_style_set_eol_filled(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (int)filled);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_reset_default)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_style_reset_default(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_underline)
{
	long style, underline;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &underline))
		return;

	gtk_scintilla_style_set_underline(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (int)underline);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_case)
{
	long style, case_force;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &case_force))
		return;

	gtk_scintilla_style_set_case(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (int)case_force);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_character_set)
{
	long style, character_set;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &character_set))
		return;

	gtk_scintilla_style_set_character_set(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (int)character_set);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_sel_fore)
{
	long use_setting, fore;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &use_setting, &fore))
		return;

	gtk_scintilla_set_sel_fore(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)use_setting, (long)fore);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_sel_back)
{
	long use_setting, back;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &use_setting, &back))
		return;

	gtk_scintilla_set_sel_back(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)use_setting, (long)back);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_caret_fore)
{
	long fore;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &fore))
		return;

	gtk_scintilla_set_caret_fore(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)fore);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_clear_all_cmd_keys)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_clear_all_cmd_keys(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_styling_ex)
{
	long length;
	char *styles;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &length, &styles))
		return;

	gtk_scintilla_set_styling_ex(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)length, styles);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_style_set_visible)
{
	long style, visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &style, &visible))
		return;

	gtk_scintilla_style_set_visible(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)style, (int)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_caret_period)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_caret_period(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_caret_period)
{
	long period_milliseconds;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &period_milliseconds))
		return;

	gtk_scintilla_set_caret_period(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)period_milliseconds);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_word_chars)
{
	char *characters;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &characters))
		return;

	gtk_scintilla_set_word_chars(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), characters);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_begin_undo_action)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_begin_undo_action(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_end_undo_action)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_end_undo_action(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_indic_set_style)
{
	long indic, style;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &indic, &style))
		return;

	gtk_scintilla_indic_set_style(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)indic, (int)style);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_indic_get_style)
{
	long indic, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &indic))
		return;

	php_retval = gtk_scintilla_indic_get_style(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)indic);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_indic_set_fore)
{
	long indic, fore;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &indic, &fore))
		return;

	gtk_scintilla_indic_set_fore(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)indic, (long)fore);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_indic_get_fore)
{
	long indic, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &indic))
		return;

	php_retval = gtk_scintilla_indic_get_fore(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)indic);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_style_bits)
{
	long bits;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &bits))
		return;

	gtk_scintilla_set_style_bits(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)bits);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_style_bits)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_style_bits(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_line_state)
{
	long line, state;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line, &state))
		return;

	gtk_scintilla_set_line_state(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line, (int)state);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_line_state)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_get_line_state(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_max_line_state)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_max_line_state(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_caret_line_visible)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_caret_line_visible(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_caret_line_visible)
{
	long show;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &show))
		return;

	gtk_scintilla_set_caret_line_visible(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)show);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_caret_line_back)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_caret_line_back(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_caret_line_back)
{
	long back;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &back))
		return;

	gtk_scintilla_set_caret_line_back(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)back);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_show)
{
	long len_entered;
	char *item_list;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &len_entered, &item_list))
		return;

	gtk_scintilla_autoc_show(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)len_entered, item_list);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_cancel)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_autoc_cancel(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_active)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_autoc_active(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_autoc_pos_start)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_autoc_pos_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_autoc_complete)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_autoc_complete(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_stops)
{
	char *character_set;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &character_set))
		return;

	gtk_scintilla_autoc_stops(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), character_set);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_set_separator)
{
	long separator_character;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &separator_character))
		return;

	gtk_scintilla_autoc_set_separator(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)separator_character);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_get_separator)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_autoc_get_separator(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_autoc_select)
{
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &text))
		return;

	gtk_scintilla_autoc_select(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), text);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_set_cancel_at_start)
{
	long cancel;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &cancel))
		return;

	gtk_scintilla_autoc_set_cancel_at_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)cancel);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_get_cancel_at_start)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_autoc_get_cancel_at_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_autoc_set_fill_ups)
{
	char *character_set;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &character_set))
		return;

	gtk_scintilla_autoc_set_fill_ups(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), character_set);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_set_choose_single)
{
	long choose_single;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &choose_single))
		return;

	gtk_scintilla_autoc_set_choose_single(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)choose_single);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_get_choose_single)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_autoc_get_choose_single(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_autoc_set_ignore_case)
{
	long ignore_case;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &ignore_case))
		return;

	gtk_scintilla_autoc_set_ignore_case(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)ignore_case);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_get_ignore_case)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_autoc_get_ignore_case(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_user_list_show)
{
	long list_type;
	char *item_list;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &list_type, &item_list))
		return;

	gtk_scintilla_user_list_show(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)list_type, item_list);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_set_auto_hide)
{
	long auto_hide;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &auto_hide))
		return;

	gtk_scintilla_autoc_set_auto_hide(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)auto_hide);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_autoc_get_auto_hide)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_autoc_get_auto_hide(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_indent)
{
	long indent_size;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &indent_size))
		return;

	gtk_scintilla_set_indent(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)indent_size);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_indent)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_indent(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_use_tabs)
{
	long use_tabs;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &use_tabs))
		return;

	gtk_scintilla_set_use_tabs(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)use_tabs);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_use_tabs)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_use_tabs(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_line_indentation)
{
	long line, indent_size;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line, &indent_size))
		return;

	gtk_scintilla_set_line_indentation(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line, (int)indent_size);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_line_indentation)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_get_line_indentation(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_line_indent_position)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_get_line_indent_position(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_column)
{
	long pos, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	php_retval = gtk_scintilla_get_column(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_h_scroll_bar)
{
	long show;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &show))
		return;

	gtk_scintilla_set_h_scroll_bar(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)show);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_h_scroll_bar)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_h_scroll_bar(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_indentation_guides)
{
	long show;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &show))
		return;

	gtk_scintilla_set_indentation_guides(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)show);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_indentation_guides)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_indentation_guides(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_highlight_guide)
{
	long column;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &column))
		return;

	gtk_scintilla_set_highlight_guide(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)column);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_highlight_guide)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_highlight_guide(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_line_end_position)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_get_line_end_position(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_code_page)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_code_page(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_caret_fore)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_caret_fore(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_use_palette)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_use_palette(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_read_only)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_read_only(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_current_pos)
{
	long pos;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	gtk_scintilla_set_current_pos(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_selection_start)
{
	long pos;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	gtk_scintilla_set_selection_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_selection_start)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_selection_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_selection_end)
{
	long pos;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	gtk_scintilla_set_selection_end(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_selection_end)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_selection_end(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_print_magnification)
{
	long magnification;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &magnification))
		return;

	gtk_scintilla_set_print_magnification(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)magnification);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_print_magnification)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_print_magnification(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_print_colour_mode)
{
	long mode;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &mode))
		return;

	gtk_scintilla_set_print_colour_mode(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)mode);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_print_colour_mode)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_print_colour_mode(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_first_visible_line)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_first_visible_line(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}

PHP_FUNCTION(gtk_scintilla_get_line)
{
	int line, length;
	char *text;
	GtkScintilla *scintilla = GTK_SCINTILLA(PHP_GTK_GET(this_ptr));

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;
	
	length = gtk_scintilla_line_length(scintilla, line) + 1;
	text = emalloc(length);
	memset(text, 0, length);

	/* Scintilla has a bug: when you try to get non-existant line, it
	   overwrites the buffer. So, we avoid it by checking length. */
	if (length > 1)
		gtk_scintilla_get_line(scintilla, line, text);

	RETURN_STRINGL(text, length-1, 0);
}

PHP_FUNCTION(gtk_scintilla_get_line_count)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_line_count(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_margin_left)
{
	long pixel_width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pixel_width))
		return;

	gtk_scintilla_set_margin_left(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)pixel_width);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_margin_left)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_margin_left(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_margin_right)
{
	long pixel_width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pixel_width))
		return;

	gtk_scintilla_set_margin_right(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)pixel_width);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_margin_right)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_margin_right(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_modify)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_modify(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_sel)
{
	long start, end;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &start, &end))
		return;

	gtk_scintilla_set_sel(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)start, (long)end);
	RETURN_NULL();
}

/* TODO: fix to properly handle rectangular selections */
PHP_FUNCTION(gtk_scintilla_get_sel_text)
{
	long length;
	char *text;
	GtkScintilla *scintilla = GTK_SCINTILLA(PHP_GTK_GET(this_ptr));

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;
	
	length = gtk_scintilla_get_selection_end(scintilla) - gtk_scintilla_get_selection_start(scintilla) + 1;
	text = emalloc(length);
	text[length-1] = 0;

	gtk_scintilla_get_sel_text(scintilla, text);

	RETURN_STRINGL(text, length-1, 0);
}

PHP_FUNCTION(gtk_scintilla_hide_selection)
{
	long normal;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &normal))
		return;

	gtk_scintilla_hide_selection(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)normal);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_point_x_from_position)
{
	long pos, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	php_retval = gtk_scintilla_point_x_from_position(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_point_y_from_position)
{
	long pos, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	php_retval = gtk_scintilla_point_y_from_position(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_line_from_position)
{
	long pos, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	php_retval = gtk_scintilla_line_from_position(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_position_from_line)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_position_from_line(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_line_scroll)
{
	long columns, lines;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &columns, &lines))
		return;

	gtk_scintilla_line_scroll(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)columns, (int)lines);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_scroll_caret)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_scroll_caret(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_replace_sel)
{
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &text))
		return;

	gtk_scintilla_replace_sel(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), text);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_read_only)
{
	long read_only;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &read_only))
		return;

	gtk_scintilla_set_read_only(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)read_only);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_null)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_null(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_can_paste)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_can_paste(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_can_undo)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_can_undo(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_empty_undo_buffer)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_empty_undo_buffer(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_undo)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_undo(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_cut)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_cut(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_copy)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_copy(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_paste)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_paste(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_clear)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_clear(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_text)
{
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &text))
		return;

	gtk_scintilla_set_text(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), text);
	RETURN_NULL();
}

PHP_FUNCTION(gtk_scintilla_get_text)
{
	int length;
	char *text;
	GtkScintilla *scintilla = GTK_SCINTILLA(PHP_GTK_GET(this_ptr));

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;
	
	length = gtk_scintilla_get_text_length(scintilla) + 1;
	text = emalloc(length);

	/* This function null-terminates the string. */
	gtk_scintilla_get_text(scintilla, length, text);

	RETURN_STRINGL(text, length-1, 0);
}

PHP_FUNCTION(gtk_scintilla_get_text_length)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_text_length(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_direct_function)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_direct_function(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_direct_pointer)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_direct_pointer(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_overtype)
{
	long overtype;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &overtype))
		return;

	gtk_scintilla_set_overtype(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)overtype);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_overtype)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_overtype(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_caret_width)
{
	long pixel_width;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pixel_width))
		return;

	gtk_scintilla_set_caret_width(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)pixel_width);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_caret_width)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_caret_width(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_target_start)
{
	long pos;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	gtk_scintilla_set_target_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_target_start)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_target_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_target_end)
{
	long pos;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	gtk_scintilla_set_target_end(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_target_end)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_target_end(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}

PHP_FUNCTION(gtk_scintilla_replace_target)
{
	int length;
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s#", &text, &length))
		return;

	length = gtk_scintilla_replace_target(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), length, text);

	RETURN_LONG(length);
}
PHP_FUNCTION(gtk_scintilla_replace_target_re)
{
	int length;
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s#", &text, &length))
		return;

	length = gtk_scintilla_replace_target_re(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), length, text);

	RETURN_LONG(length);
}
PHP_FUNCTION(gtk_scintilla_search_in_target)
{
	int length, pos;
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s#", &text, &length))
		return;

	RETURN_LONG(gtk_search_in_target(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), length, text));
}

PHP_FUNCTION(gtk_scintilla_set_search_flags)
{
	long flags;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &flags))
		return;

	gtk_scintilla_set_search_flags(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)flags);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_search_flags)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_search_flags(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_call_tip_show)
{
	long pos;
	char *definition;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &pos, &definition))
		return;

	gtk_scintilla_call_tip_show(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos, definition);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_call_tip_cancel)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_call_tip_cancel(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_call_tip_active)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_call_tip_active(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_call_tip_pos_start)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_call_tip_pos_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_call_tip_set_hlt)
{
	long start, end;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &start, &end))
		return;

	gtk_scintilla_call_tip_set_hlt(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)start, (int)end);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_call_tip_set_back)
{
	long back;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &back))
		return;

	gtk_scintilla_call_tip_set_back(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)back);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_visible_from_doc_line)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_visible_from_doc_line(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_doc_line_from_visible)
{
	long line_display, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line_display))
		return;

	php_retval = gtk_scintilla_doc_line_from_visible(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line_display);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_fold_level)
{
	long line, level;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line, &level))
		return;

	gtk_scintilla_set_fold_level(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line, (int)level);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_fold_level)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_get_fold_level(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_last_child)
{
	long line, level, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line, &level))
		return;

	php_retval = gtk_scintilla_get_last_child(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line, (int)level);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_fold_parent)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_get_fold_parent(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_show_lines)
{
	long line_start, line_end;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line_start, &line_end))
		return;

	gtk_scintilla_show_lines(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line_start, (int)line_end);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_hide_lines)
{
	long line_start, line_end;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line_start, &line_end))
		return;

	gtk_scintilla_hide_lines(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line_start, (int)line_end);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_line_visible)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_get_line_visible(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_fold_expanded)
{
	long line, expanded;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &line, &expanded))
		return;

	gtk_scintilla_set_fold_expanded(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line, (int)expanded);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_fold_expanded)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_get_fold_expanded(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_toggle_fold)
{
	long line;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	gtk_scintilla_toggle_fold(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_ensure_visible)
{
	long line;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	gtk_scintilla_ensure_visible(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_fold_flags)
{
	long flags;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &flags))
		return;

	gtk_scintilla_set_fold_flags(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)flags);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_tab_indents)
{
	long tab_indents;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &tab_indents))
		return;

	gtk_scintilla_set_tab_indents(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)tab_indents);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_tab_indents)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_tab_indents(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_backspace_unindents)
{
	long bs_unindents;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &bs_unindents))
		return;

	gtk_scintilla_set_backspace_unindents(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)bs_unindents);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_backspace_unindents)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_backspace_unindents(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_line_down)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_down(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_down_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_down_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_up)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_up(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_up_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_up_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_char_left)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_char_left(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_char_left_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_char_left_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_char_right)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_char_right(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_char_right_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_char_right_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_word_left)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_word_left(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_word_left_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_word_left_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_word_right)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_word_right(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_word_right_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_word_right_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_home)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_home(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_home_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_home_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_end)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_end(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_end_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_end_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_document_start)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_document_start(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_document_start_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_document_start_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_document_end)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_document_end(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_document_end_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_document_end_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_page_up)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_page_up(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_page_up_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_page_up_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_page_down)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_page_down(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_page_down_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_page_down_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_edit_toggle_overtype)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_edit_toggle_overtype(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_cancel)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_cancel(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_delete_back)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_delete_back(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_tab)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_tab(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_back_tab)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_back_tab(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_new_line)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_new_line(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_form_feed)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_form_feed(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_v_c_home)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_v_c_home(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_v_c_home_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_v_c_home_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_zoom_in)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_zoom_in(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_zoom_out)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_zoom_out(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_del_word_left)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_del_word_left(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_del_word_right)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_del_word_right(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_cut)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_cut(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_delete)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_delete(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_transpose)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_transpose(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_lower_case)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_lower_case(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_upper_case)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_upper_case(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_scroll_down)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_scroll_down(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_scroll_up)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_line_scroll_up(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_move_caret_inside_view)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_move_caret_inside_view(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_line_length)
{
	long line, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &line))
		return;

	php_retval = gtk_scintilla_line_length(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)line);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_brace_highlight)
{
	long pos1, pos2;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &pos1, &pos2))
		return;

	gtk_scintilla_brace_highlight(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos1, (long)pos2);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_brace_bad_light)
{
	long pos;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	gtk_scintilla_brace_bad_light(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_brace_match)
{
	long pos, php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pos))
		return;

	php_retval = gtk_scintilla_brace_match(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)pos);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_get_view_eol)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_view_eol(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_view_eol)
{
	long visible;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &visible))
		return;

	gtk_scintilla_set_view_eol(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)visible);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_doc_pointer)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_doc_pointer(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_doc_pointer)
{
	long pointer;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &pointer))
		return;

	gtk_scintilla_set_doc_pointer(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)pointer);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_mod_event_mask)
{
	long mask;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &mask))
		return;

	gtk_scintilla_set_mod_event_mask(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)mask);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_edge_column)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_edge_column(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_edge_column)
{
	long column;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &column))
		return;

	gtk_scintilla_set_edge_column(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)column);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_edge_mode)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_edge_mode(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_edge_mode)
{
	long mode;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &mode))
		return;

	gtk_scintilla_set_edge_mode(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)mode);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_edge_colour)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_edge_colour(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_edge_colour)
{
	long edge_colour;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &edge_colour))
		return;

	gtk_scintilla_set_edge_colour(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)edge_colour);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_search_anchor)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_search_anchor(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_search_next)
{
	long flags, php_retval;
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &flags, &text))
		return;

	php_retval = gtk_scintilla_search_next(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)flags, text);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_search_prev)
{
	long flags, php_retval;
	char *text;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &flags, &text))
		return;

	php_retval = gtk_scintilla_search_prev(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)flags, text);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_caret_policy)
{
	long caret_policy, caret_slop;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &caret_policy, &caret_slop))
		return;

	gtk_scintilla_set_caret_policy(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)caret_policy, (int)caret_slop);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_lines_on_screen)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_lines_on_screen(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_use_pop_up)
{
	long allow_pop_up;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &allow_pop_up))
		return;

	gtk_scintilla_use_pop_up(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)allow_pop_up);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_selection_is_rectangle)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_selection_is_rectangle(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_zoom)
{
	long zoom;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &zoom))
		return;

	gtk_scintilla_set_zoom(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)zoom);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_zoom)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_zoom(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_create_document)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_create_document(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_add_ref_document)
{
	long doc;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &doc))
		return;

	gtk_scintilla_add_ref_document(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)doc);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_release_document)
{
	long doc;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &doc))
		return;

	gtk_scintilla_release_document(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)doc);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_mod_event_mask)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_mod_event_mask(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_focus)
{
	long focus;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &focus))
		return;

	gtk_scintilla_set_focus(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)focus);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_focus)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_focus(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_status)
{
	long status_code;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &status_code))
		return;

	gtk_scintilla_set_status(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)status_code);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_status)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_status(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_mouse_down_captures)
{
	long captures;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &captures))
		return;

	gtk_scintilla_set_mouse_down_captures(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)captures);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_mouse_down_captures)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_mouse_down_captures(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_set_cursor)
{
	long cursor_type;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &cursor_type))
		return;

	gtk_scintilla_set_cursor(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)cursor_type);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_cursor)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_cursor(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_word_part_left)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_word_part_left(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_word_part_left_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_word_part_left_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_word_part_right)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_word_part_right(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_word_part_right_extend)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_word_part_right_extend(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_visible_policy)
{
	long visible_policy, visible_slop;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &visible_policy, &visible_slop))
		return;

	gtk_scintilla_set_visible_policy(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)visible_policy, (int)visible_slop);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_del_line_left)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_del_line_left(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_del_line_right)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_del_line_right(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_grab_focus)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_grab_focus(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_start_record)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_start_record(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_stop_record)
{
	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gtk_scintilla_stop_record(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_lexer)
{
	long lexer;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &lexer))
		return;

	gtk_scintilla_set_lexer(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)lexer);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_get_lexer)
{
	long php_retval;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gtk_scintilla_get_lexer(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)));
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gtk_scintilla_colourise)
{
	long start, end;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ii", &start, &end))
		return;

	gtk_scintilla_colourise(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (long)start, (long)end);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_property)
{
	char *key, *value;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "ss", &key, &value))
		return;

	gtk_scintilla_set_property(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), key, value);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_keywords)
{
	long keyword_set;
	char *key_words;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "is", &keyword_set, &key_words))
		return;

	gtk_scintilla_set_keywords(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), (int)keyword_set, key_words);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_scintilla_set_lexer_language)
{
	char *language;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &language))
		return;

	gtk_scintilla_set_lexer_language(GTK_SCINTILLA(PHP_GTK_GET(this_ptr)), language);
	RETURN_NULL();
}


static function_entry php_gtk_scintilla_functions[] = {
	{"GtkScintilla",	PHP_FN(gtk_scintilla_new),	NULL},
	{"gtkscintilla",	PHP_FN(gtk_scintilla_new),	NULL},
	{"get_type",	PHP_FN(gtk_scintilla_get_type),	NULL},
	{"find_text",	PHP_FN(gtk_scintilla_find_text),	NULL},
	{"add_text",	PHP_FN(gtk_scintilla_add_text),	NULL},
	{"insert_text",	PHP_FN(gtk_scintilla_insert_text),	NULL},
	{"clear_all",	PHP_FN(gtk_scintilla_clear_all),	NULL},
	{"clear_document_style",	PHP_FN(gtk_scintilla_clear_document_style),	NULL},
	{"get_length",	PHP_FN(gtk_scintilla_get_length),	NULL},
	{"get_char_at",	PHP_FN(gtk_scintilla_get_char_at),	NULL},
	{"get_current_pos",	PHP_FN(gtk_scintilla_get_current_pos),	NULL},
	{"get_anchor",	PHP_FN(gtk_scintilla_get_anchor),	NULL},
	{"get_style_at",	PHP_FN(gtk_scintilla_get_style_at),	NULL},
	{"redo",	PHP_FN(gtk_scintilla_redo),	NULL},
	{"set_undo_collection",	PHP_FN(gtk_scintilla_set_undo_collection),	NULL},
	{"select_all",	PHP_FN(gtk_scintilla_select_all),	NULL},
	{"set_save_point",	PHP_FN(gtk_scintilla_set_save_point),	NULL},
	{"can_redo",	PHP_FN(gtk_scintilla_can_redo),	NULL},
	{"marker_line_from_handle",	PHP_FN(gtk_scintilla_marker_line_from_handle),	NULL},
	{"marker_delete_handle",	PHP_FN(gtk_scintilla_marker_delete_handle),	NULL},
	{"get_undo_collection",	PHP_FN(gtk_scintilla_get_undo_collection),	NULL},
	{"get_view_ws",	PHP_FN(gtk_scintilla_get_view_ws),	NULL},
	{"set_view_ws",	PHP_FN(gtk_scintilla_set_view_ws),	NULL},
	{"position_from_point",	PHP_FN(gtk_scintilla_position_from_point),	NULL},
	{"goto_line",	PHP_FN(gtk_scintilla_goto_line),	NULL},
	{"goto_pos",	PHP_FN(gtk_scintilla_goto_pos),	NULL},
	{"set_anchor",	PHP_FN(gtk_scintilla_set_anchor),	NULL},
	{"get_cur_line",	PHP_FN(gtk_scintilla_get_cur_line),	NULL},
	{"get_end_styled",	PHP_FN(gtk_scintilla_get_end_styled),	NULL},
	{"convert_eols",	PHP_FN(gtk_scintilla_convert_eols),	NULL},
	{"get_eol_mode",	PHP_FN(gtk_scintilla_get_eol_mode),	NULL},
	{"set_eol_mode",	PHP_FN(gtk_scintilla_set_eol_mode),	NULL},
	{"start_styling",	PHP_FN(gtk_scintilla_start_styling),	NULL},
	{"set_styling",	PHP_FN(gtk_scintilla_set_styling),	NULL},
	{"get_buffered_draw",	PHP_FN(gtk_scintilla_get_buffered_draw),	NULL},
	{"set_buffered_draw",	PHP_FN(gtk_scintilla_set_buffered_draw),	NULL},
	{"set_tab_width",	PHP_FN(gtk_scintilla_set_tab_width),	NULL},
	{"get_tab_width",	PHP_FN(gtk_scintilla_get_tab_width),	NULL},
	{"set_code_page",	PHP_FN(gtk_scintilla_set_code_page),	NULL},
	{"set_use_palette",	PHP_FN(gtk_scintilla_set_use_palette),	NULL},
	{"marker_define",	PHP_FN(gtk_scintilla_marker_define),	NULL},
	{"marker_set_fore",	PHP_FN(gtk_scintilla_marker_set_fore),	NULL},
	{"marker_set_back",	PHP_FN(gtk_scintilla_marker_set_back),	NULL},
	{"marker_add",	PHP_FN(gtk_scintilla_marker_add),	NULL},
	{"marker_delete",	PHP_FN(gtk_scintilla_marker_delete),	NULL},
	{"marker_delete_all",	PHP_FN(gtk_scintilla_marker_delete_all),	NULL},
	{"marker_get",	PHP_FN(gtk_scintilla_marker_get),	NULL},
	{"marker_next",	PHP_FN(gtk_scintilla_marker_next),	NULL},
	{"marker_previous",	PHP_FN(gtk_scintilla_marker_previous),	NULL},
	{"set_margin_type_n",	PHP_FN(gtk_scintilla_set_margin_type_n),	NULL},
	{"get_margin_type_n",	PHP_FN(gtk_scintilla_get_margin_type_n),	NULL},
	{"set_margin_width_n",	PHP_FN(gtk_scintilla_set_margin_width_n),	NULL},
	{"get_margin_width_n",	PHP_FN(gtk_scintilla_get_margin_width_n),	NULL},
	{"set_margin_mask_n",	PHP_FN(gtk_scintilla_set_margin_mask_n),	NULL},
	{"get_margin_mask_n",	PHP_FN(gtk_scintilla_get_margin_mask_n),	NULL},
	{"set_margin_sensitive_n",	PHP_FN(gtk_scintilla_set_margin_sensitive_n),	NULL},
	{"get_margin_sensitive_n",	PHP_FN(gtk_scintilla_get_margin_sensitive_n),	NULL},
	{"style_clear_all",	PHP_FN(gtk_scintilla_style_clear_all),	NULL},
	{"style_set_fore",	PHP_FN(gtk_scintilla_style_set_fore),	NULL},
	{"style_set_back",	PHP_FN(gtk_scintilla_style_set_back),	NULL},
	{"style_set_bold",	PHP_FN(gtk_scintilla_style_set_bold),	NULL},
	{"style_set_italic",	PHP_FN(gtk_scintilla_style_set_italic),	NULL},
	{"style_set_size",	PHP_FN(gtk_scintilla_style_set_size),	NULL},
	{"style_set_font",	PHP_FN(gtk_scintilla_style_set_font),	NULL},
	{"style_set_eol_filled",	PHP_FN(gtk_scintilla_style_set_eol_filled),	NULL},
	{"style_reset_default",	PHP_FN(gtk_scintilla_style_reset_default),	NULL},
	{"style_set_underline",	PHP_FN(gtk_scintilla_style_set_underline),	NULL},
	{"style_set_case",	PHP_FN(gtk_scintilla_style_set_case),	NULL},
	{"style_set_character_set",	PHP_FN(gtk_scintilla_style_set_character_set),	NULL},
	{"set_sel_fore",	PHP_FN(gtk_scintilla_set_sel_fore),	NULL},
	{"set_sel_back",	PHP_FN(gtk_scintilla_set_sel_back),	NULL},
	{"set_caret_fore",	PHP_FN(gtk_scintilla_set_caret_fore),	NULL},
	{"clear_all_cmd_keys",	PHP_FN(gtk_scintilla_clear_all_cmd_keys),	NULL},
	{"set_styling_ex",	PHP_FN(gtk_scintilla_set_styling_ex),	NULL},
	{"style_set_visible",	PHP_FN(gtk_scintilla_style_set_visible),	NULL},
	{"get_caret_period",	PHP_FN(gtk_scintilla_get_caret_period),	NULL},
	{"set_caret_period",	PHP_FN(gtk_scintilla_set_caret_period),	NULL},
	{"set_word_chars",	PHP_FN(gtk_scintilla_set_word_chars),	NULL},
	{"begin_undo_action",	PHP_FN(gtk_scintilla_begin_undo_action),	NULL},
	{"end_undo_action",	PHP_FN(gtk_scintilla_end_undo_action),	NULL},
	{"indic_set_style",	PHP_FN(gtk_scintilla_indic_set_style),	NULL},
	{"indic_get_style",	PHP_FN(gtk_scintilla_indic_get_style),	NULL},
	{"indic_set_fore",	PHP_FN(gtk_scintilla_indic_set_fore),	NULL},
	{"indic_get_fore",	PHP_FN(gtk_scintilla_indic_get_fore),	NULL},
	{"set_style_bits",	PHP_FN(gtk_scintilla_set_style_bits),	NULL},
	{"get_style_bits",	PHP_FN(gtk_scintilla_get_style_bits),	NULL},
	{"set_line_state",	PHP_FN(gtk_scintilla_set_line_state),	NULL},
	{"get_line_state",	PHP_FN(gtk_scintilla_get_line_state),	NULL},
	{"get_max_line_state",	PHP_FN(gtk_scintilla_get_max_line_state),	NULL},
	{"get_caret_line_visible",	PHP_FN(gtk_scintilla_get_caret_line_visible),	NULL},
	{"set_caret_line_visible",	PHP_FN(gtk_scintilla_set_caret_line_visible),	NULL},
	{"get_caret_line_back",	PHP_FN(gtk_scintilla_get_caret_line_back),	NULL},
	{"set_caret_line_back",	PHP_FN(gtk_scintilla_set_caret_line_back),	NULL},
	{"autoc_show",	PHP_FN(gtk_scintilla_autoc_show),	NULL},
	{"autoc_cancel",	PHP_FN(gtk_scintilla_autoc_cancel),	NULL},
	{"autoc_active",	PHP_FN(gtk_scintilla_autoc_active),	NULL},
	{"autoc_pos_start",	PHP_FN(gtk_scintilla_autoc_pos_start),	NULL},
	{"autoc_complete",	PHP_FN(gtk_scintilla_autoc_complete),	NULL},
	{"autoc_stops",	PHP_FN(gtk_scintilla_autoc_stops),	NULL},
	{"autoc_set_separator",	PHP_FN(gtk_scintilla_autoc_set_separator),	NULL},
	{"autoc_get_separator",	PHP_FN(gtk_scintilla_autoc_get_separator),	NULL},
	{"autoc_select",	PHP_FN(gtk_scintilla_autoc_select),	NULL},
	{"autoc_set_cancel_at_start",	PHP_FN(gtk_scintilla_autoc_set_cancel_at_start),	NULL},
	{"autoc_get_cancel_at_start",	PHP_FN(gtk_scintilla_autoc_get_cancel_at_start),	NULL},
	{"autoc_set_fill_ups",	PHP_FN(gtk_scintilla_autoc_set_fill_ups),	NULL},
	{"autoc_set_choose_single",	PHP_FN(gtk_scintilla_autoc_set_choose_single),	NULL},
	{"autoc_get_choose_single",	PHP_FN(gtk_scintilla_autoc_get_choose_single),	NULL},
	{"autoc_set_ignore_case",	PHP_FN(gtk_scintilla_autoc_set_ignore_case),	NULL},
	{"autoc_get_ignore_case",	PHP_FN(gtk_scintilla_autoc_get_ignore_case),	NULL},
	{"user_list_show",	PHP_FN(gtk_scintilla_user_list_show),	NULL},
	{"autoc_set_auto_hide",	PHP_FN(gtk_scintilla_autoc_set_auto_hide),	NULL},
	{"autoc_get_auto_hide",	PHP_FN(gtk_scintilla_autoc_get_auto_hide),	NULL},
	{"set_indent",	PHP_FN(gtk_scintilla_set_indent),	NULL},
	{"get_indent",	PHP_FN(gtk_scintilla_get_indent),	NULL},
	{"set_use_tabs",	PHP_FN(gtk_scintilla_set_use_tabs),	NULL},
	{"get_use_tabs",	PHP_FN(gtk_scintilla_get_use_tabs),	NULL},
	{"set_line_indentation",	PHP_FN(gtk_scintilla_set_line_indentation),	NULL},
	{"get_line_indentation",	PHP_FN(gtk_scintilla_get_line_indentation),	NULL},
	{"get_line_indent_position",	PHP_FN(gtk_scintilla_get_line_indent_position),	NULL},
	{"get_column",	PHP_FN(gtk_scintilla_get_column),	NULL},
	{"set_h_scroll_bar",	PHP_FN(gtk_scintilla_set_h_scroll_bar),	NULL},
	{"get_h_scroll_bar",	PHP_FN(gtk_scintilla_get_h_scroll_bar),	NULL},
	{"set_indentation_guides",	PHP_FN(gtk_scintilla_set_indentation_guides),	NULL},
	{"get_indentation_guides",	PHP_FN(gtk_scintilla_get_indentation_guides),	NULL},
	{"set_highlight_guide",	PHP_FN(gtk_scintilla_set_highlight_guide),	NULL},
	{"get_highlight_guide",	PHP_FN(gtk_scintilla_get_highlight_guide),	NULL},
	{"get_line_end_position",	PHP_FN(gtk_scintilla_get_line_end_position),	NULL},
	{"get_code_page",	PHP_FN(gtk_scintilla_get_code_page),	NULL},
	{"get_caret_fore",	PHP_FN(gtk_scintilla_get_caret_fore),	NULL},
	{"get_use_palette",	PHP_FN(gtk_scintilla_get_use_palette),	NULL},
	{"get_read_only",	PHP_FN(gtk_scintilla_get_read_only),	NULL},
	{"set_current_pos",	PHP_FN(gtk_scintilla_set_current_pos),	NULL},
	{"set_selection_start",	PHP_FN(gtk_scintilla_set_selection_start),	NULL},
	{"get_selection_start",	PHP_FN(gtk_scintilla_get_selection_start),	NULL},
	{"set_selection_end",	PHP_FN(gtk_scintilla_set_selection_end),	NULL},
	{"get_selection_end",	PHP_FN(gtk_scintilla_get_selection_end),	NULL},
	{"set_print_magnification",	PHP_FN(gtk_scintilla_set_print_magnification),	NULL},
	{"get_print_magnification",	PHP_FN(gtk_scintilla_get_print_magnification),	NULL},
	{"set_print_colour_mode",	PHP_FN(gtk_scintilla_set_print_colour_mode),	NULL},
	{"get_print_colour_mode",	PHP_FN(gtk_scintilla_get_print_colour_mode),	NULL},
	{"get_first_visible_line",	PHP_FN(gtk_scintilla_get_first_visible_line),	NULL},
	{"get_line",	PHP_FN(gtk_scintilla_get_line),	NULL},
	{"get_line_count",	PHP_FN(gtk_scintilla_get_line_count),	NULL},
	{"set_margin_left",	PHP_FN(gtk_scintilla_set_margin_left),	NULL},
	{"get_margin_left",	PHP_FN(gtk_scintilla_get_margin_left),	NULL},
	{"set_margin_right",	PHP_FN(gtk_scintilla_set_margin_right),	NULL},
	{"get_margin_right",	PHP_FN(gtk_scintilla_get_margin_right),	NULL},
	{"get_modify",	PHP_FN(gtk_scintilla_get_modify),	NULL},
	{"set_sel",	PHP_FN(gtk_scintilla_set_sel),	NULL},
	{"get_sel_text",	PHP_FN(gtk_scintilla_get_sel_text),	NULL},
	{"hide_selection",	PHP_FN(gtk_scintilla_hide_selection),	NULL},
	{"point_x_from_position",	PHP_FN(gtk_scintilla_point_x_from_position),	NULL},
	{"point_y_from_position",	PHP_FN(gtk_scintilla_point_y_from_position),	NULL},
	{"line_from_position",	PHP_FN(gtk_scintilla_line_from_position),	NULL},
	{"position_from_line",	PHP_FN(gtk_scintilla_position_from_line),	NULL},
	{"line_scroll",	PHP_FN(gtk_scintilla_line_scroll),	NULL},
	{"scroll_caret",	PHP_FN(gtk_scintilla_scroll_caret),	NULL},
	{"replace_sel",	PHP_FN(gtk_scintilla_replace_sel),	NULL},
	{"set_read_only",	PHP_FN(gtk_scintilla_set_read_only),	NULL},
	{"null",	PHP_FN(gtk_scintilla_null),	NULL},
	{"can_paste",	PHP_FN(gtk_scintilla_can_paste),	NULL},
	{"can_undo",	PHP_FN(gtk_scintilla_can_undo),	NULL},
	{"empty_undo_buffer",	PHP_FN(gtk_scintilla_empty_undo_buffer),	NULL},
	{"undo",	PHP_FN(gtk_scintilla_undo),	NULL},
	{"cut",	PHP_FN(gtk_scintilla_cut),	NULL},
	{"copy",	PHP_FN(gtk_scintilla_copy),	NULL},
	{"paste",	PHP_FN(gtk_scintilla_paste),	NULL},
	{"clear",	PHP_FN(gtk_scintilla_clear),	NULL},
	{"set_text",	PHP_FN(gtk_scintilla_set_text),	NULL},
	{"get_text",	PHP_FN(gtk_scintilla_get_text),	NULL},
	{"get_text_length",	PHP_FN(gtk_scintilla_get_text_length),	NULL},
	{"get_direct_function",	PHP_FN(gtk_scintilla_get_direct_function),	NULL},
	{"get_direct_pointer",	PHP_FN(gtk_scintilla_get_direct_pointer),	NULL},
	{"set_overtype",	PHP_FN(gtk_scintilla_set_overtype),	NULL},
	{"get_overtype",	PHP_FN(gtk_scintilla_get_overtype),	NULL},
	{"set_caret_width",	PHP_FN(gtk_scintilla_set_caret_width),	NULL},
	{"get_caret_width",	PHP_FN(gtk_scintilla_get_caret_width),	NULL},
	{"set_target_start",	PHP_FN(gtk_scintilla_set_target_start),	NULL},
	{"get_target_start",	PHP_FN(gtk_scintilla_get_target_start),	NULL},
	{"set_target_end",	PHP_FN(gtk_scintilla_set_target_end),	NULL},
	{"get_target_end",	PHP_FN(gtk_scintilla_get_target_end),	NULL},
	{"replace_target",	PHP_FN(gtk_scintilla_replace_target),	NULL},
	{"replace_target_re",	PHP_FN(gtk_scintilla_replace_target_re),	NULL},
	{"search_in_target",	PHP_FN(gtk_scintilla_search_in_target),	NULL},
	{"set_search_flags",	PHP_FN(gtk_scintilla_set_search_flags),	NULL},
	{"get_search_flags",	PHP_FN(gtk_scintilla_get_search_flags),	NULL},
	{"call_tip_show",	PHP_FN(gtk_scintilla_call_tip_show),	NULL},
	{"call_tip_cancel",	PHP_FN(gtk_scintilla_call_tip_cancel),	NULL},
	{"call_tip_active",	PHP_FN(gtk_scintilla_call_tip_active),	NULL},
	{"call_tip_pos_start",	PHP_FN(gtk_scintilla_call_tip_pos_start),	NULL},
	{"call_tip_set_hlt",	PHP_FN(gtk_scintilla_call_tip_set_hlt),	NULL},
	{"call_tip_set_back",	PHP_FN(gtk_scintilla_call_tip_set_back),	NULL},
	{"visible_from_doc_line",	PHP_FN(gtk_scintilla_visible_from_doc_line),	NULL},
	{"doc_line_from_visible",	PHP_FN(gtk_scintilla_doc_line_from_visible),	NULL},
	{"set_fold_level",	PHP_FN(gtk_scintilla_set_fold_level),	NULL},
	{"get_fold_level",	PHP_FN(gtk_scintilla_get_fold_level),	NULL},
	{"get_last_child",	PHP_FN(gtk_scintilla_get_last_child),	NULL},
	{"get_fold_parent",	PHP_FN(gtk_scintilla_get_fold_parent),	NULL},
	{"show_lines",	PHP_FN(gtk_scintilla_show_lines),	NULL},
	{"hide_lines",	PHP_FN(gtk_scintilla_hide_lines),	NULL},
	{"get_line_visible",	PHP_FN(gtk_scintilla_get_line_visible),	NULL},
	{"set_fold_expanded",	PHP_FN(gtk_scintilla_set_fold_expanded),	NULL},
	{"get_fold_expanded",	PHP_FN(gtk_scintilla_get_fold_expanded),	NULL},
	{"toggle_fold",	PHP_FN(gtk_scintilla_toggle_fold),	NULL},
	{"ensure_visible",	PHP_FN(gtk_scintilla_ensure_visible),	NULL},
	{"set_fold_flags",	PHP_FN(gtk_scintilla_set_fold_flags),	NULL},
	{"set_tab_indents",	PHP_FN(gtk_scintilla_set_tab_indents),	NULL},
	{"get_tab_indents",	PHP_FN(gtk_scintilla_get_tab_indents),	NULL},
	{"set_backspace_unindents",	PHP_FN(gtk_scintilla_set_backspace_unindents),	NULL},
	{"get_backspace_unindents",	PHP_FN(gtk_scintilla_get_backspace_unindents),	NULL},
	{"line_down",	PHP_FN(gtk_scintilla_line_down),	NULL},
	{"line_down_extend",	PHP_FN(gtk_scintilla_line_down_extend),	NULL},
	{"line_up",	PHP_FN(gtk_scintilla_line_up),	NULL},
	{"line_up_extend",	PHP_FN(gtk_scintilla_line_up_extend),	NULL},
	{"char_left",	PHP_FN(gtk_scintilla_char_left),	NULL},
	{"char_left_extend",	PHP_FN(gtk_scintilla_char_left_extend),	NULL},
	{"char_right",	PHP_FN(gtk_scintilla_char_right),	NULL},
	{"char_right_extend",	PHP_FN(gtk_scintilla_char_right_extend),	NULL},
	{"word_left",	PHP_FN(gtk_scintilla_word_left),	NULL},
	{"word_left_extend",	PHP_FN(gtk_scintilla_word_left_extend),	NULL},
	{"word_right",	PHP_FN(gtk_scintilla_word_right),	NULL},
	{"word_right_extend",	PHP_FN(gtk_scintilla_word_right_extend),	NULL},
	{"home",	PHP_FN(gtk_scintilla_home),	NULL},
	{"home_extend",	PHP_FN(gtk_scintilla_home_extend),	NULL},
	{"line_end",	PHP_FN(gtk_scintilla_line_end),	NULL},
	{"line_end_extend",	PHP_FN(gtk_scintilla_line_end_extend),	NULL},
	{"document_start",	PHP_FN(gtk_scintilla_document_start),	NULL},
	{"document_start_extend",	PHP_FN(gtk_scintilla_document_start_extend),	NULL},
	{"document_end",	PHP_FN(gtk_scintilla_document_end),	NULL},
	{"document_end_extend",	PHP_FN(gtk_scintilla_document_end_extend),	NULL},
	{"page_up",	PHP_FN(gtk_scintilla_page_up),	NULL},
	{"page_up_extend",	PHP_FN(gtk_scintilla_page_up_extend),	NULL},
	{"page_down",	PHP_FN(gtk_scintilla_page_down),	NULL},
	{"page_down_extend",	PHP_FN(gtk_scintilla_page_down_extend),	NULL},
	{"edit_toggle_overtype",	PHP_FN(gtk_scintilla_edit_toggle_overtype),	NULL},
	{"cancel",	PHP_FN(gtk_scintilla_cancel),	NULL},
	{"delete_back",	PHP_FN(gtk_scintilla_delete_back),	NULL},
	{"tab",	PHP_FN(gtk_scintilla_tab),	NULL},
	{"back_tab",	PHP_FN(gtk_scintilla_back_tab),	NULL},
	{"new_line",	PHP_FN(gtk_scintilla_new_line),	NULL},
	{"form_feed",	PHP_FN(gtk_scintilla_form_feed),	NULL},
	{"v_c_home",	PHP_FN(gtk_scintilla_v_c_home),	NULL},
	{"v_c_home_extend",	PHP_FN(gtk_scintilla_v_c_home_extend),	NULL},
	{"zoom_in",	PHP_FN(gtk_scintilla_zoom_in),	NULL},
	{"zoom_out",	PHP_FN(gtk_scintilla_zoom_out),	NULL},
	{"del_word_left",	PHP_FN(gtk_scintilla_del_word_left),	NULL},
	{"del_word_right",	PHP_FN(gtk_scintilla_del_word_right),	NULL},
	{"line_cut",	PHP_FN(gtk_scintilla_line_cut),	NULL},
	{"line_delete",	PHP_FN(gtk_scintilla_line_delete),	NULL},
	{"line_transpose",	PHP_FN(gtk_scintilla_line_transpose),	NULL},
	{"lower_case",	PHP_FN(gtk_scintilla_lower_case),	NULL},
	{"upper_case",	PHP_FN(gtk_scintilla_upper_case),	NULL},
	{"line_scroll_down",	PHP_FN(gtk_scintilla_line_scroll_down),	NULL},
	{"line_scroll_up",	PHP_FN(gtk_scintilla_line_scroll_up),	NULL},
	{"move_caret_inside_view",	PHP_FN(gtk_scintilla_move_caret_inside_view),	NULL},
	{"line_length",	PHP_FN(gtk_scintilla_line_length),	NULL},
	{"brace_highlight",	PHP_FN(gtk_scintilla_brace_highlight),	NULL},
	{"brace_bad_light",	PHP_FN(gtk_scintilla_brace_bad_light),	NULL},
	{"brace_match",	PHP_FN(gtk_scintilla_brace_match),	NULL},
	{"get_view_eol",	PHP_FN(gtk_scintilla_get_view_eol),	NULL},
	{"set_view_eol",	PHP_FN(gtk_scintilla_set_view_eol),	NULL},
	{"get_doc_pointer",	PHP_FN(gtk_scintilla_get_doc_pointer),	NULL},
	{"set_doc_pointer",	PHP_FN(gtk_scintilla_set_doc_pointer),	NULL},
	{"set_mod_event_mask",	PHP_FN(gtk_scintilla_set_mod_event_mask),	NULL},
	{"get_edge_column",	PHP_FN(gtk_scintilla_get_edge_column),	NULL},
	{"set_edge_column",	PHP_FN(gtk_scintilla_set_edge_column),	NULL},
	{"get_edge_mode",	PHP_FN(gtk_scintilla_get_edge_mode),	NULL},
	{"set_edge_mode",	PHP_FN(gtk_scintilla_set_edge_mode),	NULL},
	{"get_edge_colour",	PHP_FN(gtk_scintilla_get_edge_colour),	NULL},
	{"set_edge_colour",	PHP_FN(gtk_scintilla_set_edge_colour),	NULL},
	{"search_anchor",	PHP_FN(gtk_scintilla_search_anchor),	NULL},
	{"search_next",	PHP_FN(gtk_scintilla_search_next),	NULL},
	{"search_prev",	PHP_FN(gtk_scintilla_search_prev),	NULL},
	{"set_caret_policy",	PHP_FN(gtk_scintilla_set_caret_policy),	NULL},
	{"lines_on_screen",	PHP_FN(gtk_scintilla_lines_on_screen),	NULL},
	{"use_pop_up",	PHP_FN(gtk_scintilla_use_pop_up),	NULL},
	{"selection_is_rectangle",	PHP_FN(gtk_scintilla_selection_is_rectangle),	NULL},
	{"set_zoom",	PHP_FN(gtk_scintilla_set_zoom),	NULL},
	{"get_zoom",	PHP_FN(gtk_scintilla_get_zoom),	NULL},
	{"create_document",	PHP_FN(gtk_scintilla_create_document),	NULL},
	{"add_ref_document",	PHP_FN(gtk_scintilla_add_ref_document),	NULL},
	{"release_document",	PHP_FN(gtk_scintilla_release_document),	NULL},
	{"get_mod_event_mask",	PHP_FN(gtk_scintilla_get_mod_event_mask),	NULL},
	{"set_focus",	PHP_FN(gtk_scintilla_set_focus),	NULL},
	{"get_focus",	PHP_FN(gtk_scintilla_get_focus),	NULL},
	{"set_status",	PHP_FN(gtk_scintilla_set_status),	NULL},
	{"get_status",	PHP_FN(gtk_scintilla_get_status),	NULL},
	{"set_mouse_down_captures",	PHP_FN(gtk_scintilla_set_mouse_down_captures),	NULL},
	{"get_mouse_down_captures",	PHP_FN(gtk_scintilla_get_mouse_down_captures),	NULL},
	{"set_cursor",	PHP_FN(gtk_scintilla_set_cursor),	NULL},
	{"get_cursor",	PHP_FN(gtk_scintilla_get_cursor),	NULL},
	{"word_part_left",	PHP_FN(gtk_scintilla_word_part_left),	NULL},
	{"word_part_left_extend",	PHP_FN(gtk_scintilla_word_part_left_extend),	NULL},
	{"word_part_right",	PHP_FN(gtk_scintilla_word_part_right),	NULL},
	{"word_part_right_extend",	PHP_FN(gtk_scintilla_word_part_right_extend),	NULL},
	{"set_visible_policy",	PHP_FN(gtk_scintilla_set_visible_policy),	NULL},
	{"del_line_left",	PHP_FN(gtk_scintilla_del_line_left),	NULL},
	{"del_line_right",	PHP_FN(gtk_scintilla_del_line_right),	NULL},
	{"grab_focus",	PHP_FN(gtk_scintilla_grab_focus),	NULL},
	{"start_record",	PHP_FN(gtk_scintilla_start_record),	NULL},
	{"stop_record",	PHP_FN(gtk_scintilla_stop_record),	NULL},
	{"set_lexer",	PHP_FN(gtk_scintilla_set_lexer),	NULL},
	{"get_lexer",	PHP_FN(gtk_scintilla_get_lexer),	NULL},
	{"colourise",	PHP_FN(gtk_scintilla_colourise),	NULL},
	{"set_property",	PHP_FN(gtk_scintilla_set_property),	NULL},
	{"set_keywords",	PHP_FN(gtk_scintilla_set_keywords),	NULL},
	{"set_lexer_language",	PHP_FN(gtk_scintilla_set_lexer_language),	NULL},
	{NULL, NULL, NULL}
};


void php_scintilla_register_classes(void)
{
	zend_class_entry ce;
	TSRMLS_FETCH();

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkScintilla", php_gtk_scintilla_functions, NULL, NULL, php_gtk_set_property);
	gtk_scintilla_ce = zend_register_internal_class_ex(&ce, gtk_frame_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkScintilla"), gtk_scintilla_ce);


}

#endif /* HAVE_PHP_GTK */
